unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Button2: TButton;
    ClientSocket1: TClientSocket;
    procedure Button2Click(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button1Click(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure parse(s:string);
    procedure docmd(pline:string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  cnn:boolean=false;
  f:array of array of byte;

implementation

{$R *.dfm}

{-- prihlaseni/odhlaseni k serveru}
procedure TForm1.Button2Click(Sender: TObject);
  var s,host,port:string;
begin
 if cnn then begin
  button2.caption:='Connect';
  button1.Enabled:=false;
  edit2.Enabled:=true;
  cnn:=false;
  form1.ClientSocket1.Close;
  exit;
 end;
 s:=edit2.text;
 if pos (':',s)<>0 then begin
  host:=copy(s,1,pos(':',s)-1);
  port:=copy(s,pos(':',s)+1,length(s));
 end else
 begin
  host:=s;
  port:=port;
 end;
 clientsocket1.port:=strtoint(port);
 clientsocket1.host:=host;
 clientsocket1.Open;
 edit1.text:='param'; button1click(self);
end;

{--- opravdu probehlo prihlaseni}
procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 button2.caption:='Discon..';
 button1.Enabled:=true;
 edit2.Enabled:=false;
 cnn:=true;
end;

{--- odeslani zpravy serveru}
procedure TForm1.Button1Click(Sender: TObject);
begin
 if edit1.text<>'' then begin
  while ord(edit1.text[length(edit1.text)])<32 do edit1.text:=copy(edit1.text,1,length(edit1.text)-1);
  form1.ClientSocket1.Socket.SendText(edit1.text+#13#10);
  memo2.Lines.add(edit1.text);
 end;
end;

{--- rizeni provozu}
procedure tform1.docmd(pline:string);

function iscmd(s1,s2:string):boolean;
begin
 result:=copy(s1,1,length(s2))=s2;
end;

function line(s:string;p:integer):string;
 var i:integer;
begin
 if p<>0 then
  for i:=1 to p do begin
   delete(s,1,pos(' ',s));
  end;
 if pos(' ',s)<>0 then
  result:=copy(s,1,pos(' ',s)-1)
 else result:=s;
end;

begin
 if line(pline,0)='shafts' then setlength(f,strtoint(line(pline,1)));
 if line(pline,0)='levelbuttonup' then begin
  edit1.text:='lipinfo C0-UP'; button1click(self);
  edit1.text:='indiupon '+line(pline,1); button1click(self);
  edit1.text:='floor 0 '+line(pline,1); button1click(self);
  edit1.text:='open 0'; button1click(self);
  edit1.text:='indiupoff '+line(pline,1); button1click(self);
 end;
 if line(pline,0)='levelbuttondn' then begin
  edit1.text:='lipinfo C0-DN'; button1click(self);
  edit1.text:='indidnon '+line(pline,1); button1click(self);
  edit1.text:='floor 0 '+line(pline,1); button1click(self);
  edit1.text:='open 0'; button1click(self);
  edit1.text:='indidnoff '+line(pline,1); button1click(self);
 end;
 if line(pline,0)='cabinbutton' then begin
  edit1.text:='lipinfo BETTERUSESTAIRS'; button1click(self);
  edit1.text:='indion '+line(pline,1)+' '+line(pline,2); button1click(self);
  edit1.text:='close '+line(pline,1); button1click(self); sleep(5000);
  edit1.text:='floor '+line(pline,1)+' '+line(pline,2); button1click(self);
  edit1.text:='open '+line(pline,1); button1click(self);
  edit1.text:='indioff '+line(pline,1)+' '+line(pline,2); button1click(self);
 end;
{ if line(pline,0)='opened' then begin
  edit1.text:='close '+line(pline,1); button1click(self);
 end;}
end;

{--- rozdeleni odpovedi na prikazy}
procedure tform1.parse(s:string);
 var line:string;
begin
 while pos(#13,s)<>0 do begin
  line:=copy(s,1,pos(#13,s)-1);
  delete (s,1,pos(#13,s)+1);
  docmd(line);
 end;
end;

{--- precteni dat od serveru}
procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
  var s:string;
begin
 s:=form1.ClientSocket1.Socket.ReceiveText;
 form1.memo1.lines.add(s);
 parse(s);
end;

{--- odeslani prikazu pomoci enter}
procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=vk_return then button1click(self);
end;

{--- uzavreni spojeni pri zavreni aplikace}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if cnn then begin
  form1.ClientSocket1.Close;
 end;
end;

end.
